<template>
  <div class="container">
    <a href='/' @click="goBack">Go Back to search</a>
    <transition>
      <div v-if="gif">
        <img :src="gif.images.downsized.url" alt="">
        <div>
          <a :href="gif.url" target="_blank">{{gif.url}}</a>
          <p>Rating: <span>{{gif.rating}}</span></p>
          <p>Import date: <span>{{gif.import_datetime}}</span></p>
        </div>
      </div>
      <div class="preloader" v-else>
        <div class="preloader__img"></div>
        <div class="preloader__content">
          <div class="preloader__text"></div>
          <div class="preloader__text"></div>
          <div class="preloader__text"></div>
        </div>
      </div>
    </transition>
  </div>
</template>

<script>
  export default {
    name: 'gif-detail',
    props: ['id'],
    data () {
      return {
        gif: null
      }
    },
    created () {
      this.fetchData()
    },
    watch: {
      '$route': 'fetchData'
    },
    methods: {
      fetchData () {
        fetch(`http://api.giphy.com/v1/gifs/${this.id}?api_key=dc6zaTOxFJmzC&q`)
          .then((response) => response.json())
          .then(({ data }) => { this.gif = data })
      },
      goBack () {
        this.$router.go(-1)
      }
    }
  }
</script>

<style scoped>
  .container {
    margin-top: 1.5rem;
  }

  a {
    display: inline-block;
    margin-bottom: 1rem;
  }
  .preloader {
    background: #f4f4f4;
    height: 250px;
    padding: 1rem;
    display: flex;
  }

  .preloader__content {
    width: 40%;
  }

  .preloader__img {
    height: 240px;
    margin-right: 2rem;
    width: 40%;

    background: #d6d3d3;
  }

  .preloader__text {
    background: #d6d3d3;
    /*width: 40%;*/
    height: 1.5rem;
    margin-bottom: 1rem;
  }
</style>
